Skip to main content

Recursion - Easy Level - Question 2

Recursion - Easy Level - Question 2


Question 2
Leetcode 509 Fibonacci Number

The Fibonacci numbers, commonly denoted F(n) form a sequence, called the Fibonacci sequence, such that each number is the sum of the two preceding ones, starting from 0 and 1. That is,

F(0) = 0, F(1) = 1
F(n) = F(n - 1) + F(n - 2), for n > 1.
Given n, calculate F(n).

Constraints:
0 <= n <= 30

Analysis:

1. the base case is obvious: F(0) and F(1);

2. the converging formula is given directly as well;

So just need to convert them into code.


See the code below:


class Solution {
public:
    int fib(int N) {
        if(N<2) return N;
        return fib(N-1) + fib(N-2);
    }
};

But if you have learned some algorithm before and had some understanding of time and space complexity, you can immediately realize that the above method is NOT the most efficient one. The reason is that we re-calculated so many inter-mediates many times! For example, fib(N-2) was calculated when calculating fib(N-1), which was calculated again when calculating fib(N-2) itself. 

We just can use a trick called dynamic programming, to memorize the calculated states, and just reuse them when called again.

See the code below:

class Solution {
public:
    int fib(int N) {
        if(N<2) return N;
        vector<int> dp(N+1, 0);
        dp[1] = 1;
        for(int i=2; i<=N; ++i) {
            dp[i] = dp[i-1] + dp[i-2];
        }
        return dp[N];
    }
};

Since we just need the last two elements, so the space complexity can be further reduced.

class Solution {
public:
    int fib(int N) {
        if(N<2) return N;
        int a = 0, b = 1;
        for(int i=2; i<=N; ++i) {
            b += a;
            a = b - a;
        }
        return b;
    }
};


Comments

Popular posts from this blog

Binary Search - Example

Binary Search - Example Leetcode 35  Search Insert Position Given a sorted array of distinct integers and a target value, return the index if the target is found. If not, return the index where it would be if it were inserted in order. You must write an algorithm with O(log n) runtime complexity. Constraints: 1 <= nums.length <= 10^4 -10^4 <= nums[i] <= 10^4 nums contains distinct values sorted in ascending order. -10^4 <= target <= 10^4 Analysis: The array is sorted, so we just need to run a routine binary search. Make a guest first, then based on the guessed result, we can adjust the search range. See the code below: class Solution { public: int searchInsert(vector<int>& nums, int target) { int left = 0, right = nums.size(); while(left < right) { int mid = left + (right - left) / 2; if(nums[mid] < target) left = mid + 1; else right = mid; } return left; } }; If you know t...

Graph Question - Hard Level - Question 1

2246. Longest Path With Different Adjacent Characters You are given a tree (i.e. a connected, undirected graph that has no cycles) rooted at node 0 consisting of n nodes numbered from 0 to n - 1. The tree is represented by a 0-indexed array parent of size n, where parent[i] is the parent of node i. Since node 0 is the root, parent[0] == -1. You are also given a string s of length n, where s[i] is the character assigned to node i. Return the length of the longest path in the tree such that no pair of adjacent nodes on the path have the same character assigned to them. Constraints: n == parent.length == s.length 1 <= n <= 10^5 0 <= parent[i] <= n - 1 for all i >= 1 parent[0] == -1 parent represents a valid tree. s consists of only lowercase English letters. Analysis For this question, we need to construct a graph, or more specifically, a n-nary tree. How to construct the graph/tree? What we only know is the parent array. So we need to go through the parent array and constr...